/*
  CatWeasel MK3 PCI Linux driver (c) 2002 by Dirk Jagdmann <doj@cubic.org>

  This file is part of CatWeasel MK3 PCI Linux driver.

  The CatWeasel MK3 PCI Linux driver is free software; you can
  redistribute it and/or modify it under the terms of the GNU General
  Public License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  The CatWeasel MK3 PCI Linux driver is distributed in the hope that
  it will be useful, but WITHOUT ANY WARRANTY; without even the
  implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
  PURPOSE.  See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with the CatWeasel MK3 PCI Linux driver; if not, write to the
  Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA 02111-1307 USA

  $Header: /home/cvs/sidblaster/device/cw.h,v 1.2 2003/05/17 16:29:41 doj Exp $
*/

/*
  General header file used to include some standard linux stuff
*/

#ifndef CW__H
#define CW__H

#include <linux/config.h>

#if !defined(CONFIG_PCI)
#error Linux Kernel needs PCI support for CatWeasel MK3
#endif

#include <linux/version.h>

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,4,18)
#error Linux Version >= 2.4.18 needed for this driver
#endif

#include <linux/modversions.h>
#include <linux/module.h>

#include "cwsid.h"

#ifndef SEEK_SET
#define SEEK_SET 0
#endif
#ifndef SEEK_CUR
#define SEEK_CUR 1
#endif
#ifndef SEEK_END
#define SEEK_END 2
#endif

enum {
  JoyDat,
  PaddleSelect,
  JoyButton,
  JoyButtondir,
  KeyDat,
  KeyStatus,
  SidDat,
  SidCommand,
  CatMem,
  CatAbort,
  CatControl,
  CatOption,
  CatStartA,
  CatStartB,
  CatIRQ,
  RegisterNum
};

extern int cw_num;
extern int cw_register[CWSID_MAX_NUM][RegisterNum];

int  cwsid_init();
void cwsid_exit();
unsigned char sid_read(unsigned char addr, int sid);

int  cwjoy_init();
void cwjoy_exit();

#endif
