/*
  CatWeasel MK3 PCI Linux driver (c) 2002 by Dirk Jagdmann <doj@cubic.org>

  This file is part of CatWeasel MK3 PCI Linux driver.

  The CatWeasel MK3 PCI Linux driver is free software; you can
  redistribute it and/or modify it under the terms of the GNU General
  Public License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  The CatWeasel MK3 PCI Linux driver is distributed in the hope that
  it will be useful, but WITHOUT ANY WARRANTY; without even the
  implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
  PURPOSE.  See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with the CatWeasel MK3 PCI Linux driver; if not, write to the
  Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA 02111-1307 USA

  $Header: /home/cvs/sidblaster/device/cwsid.h,v 1.5 2003/05/31 10:34:00 doj Exp $
*/

/*
  ioctls for SID device
*/

#ifndef DEVSID__H
#define DEVSID__H

#include <linux/ioctl.h>

/* The ioctl numbers are modelled after the hardsid linux device
   driver, so a software may autodetect which device is present behind
   a /dev/sid.
   http://hardsid.sourceforge.net/
 */

#define CWSID_IOCTL_TYPE ('S')

#define CWSID_IOCTL_RESET    _IO (CWSID_IOCTL_TYPE, 0)
#define CWSID_IOCTL_SIDTYPE  _IOR(CWSID_IOCTL_TYPE, 3, int)
#define CWSID_IOCTL_CARDTYPE _IOR(CWSID_IOCTL_TYPE, 4, int)
#define CWSID_IOCTL_IRQAVAIL _IOR(CWSID_IOCTL_TYPE, 5, int)

#define CWSID_IOCTL_WAITIRQ  _IO (CWSID_IOCTL_TYPE, 0x10)
#define CWSID_IOCTL_PAL      _IO (CWSID_IOCTL_TYPE, 0x11)
#define CWSID_IOCTL_NTSC     _IO (CWSID_IOCTL_TYPE, 0x12)

#define CWSID_IOCTL_SETHZ    _IOW(CWSID_IOCTL_TYPE, 0x20,int)
#define CWSID_IOCTL_DELAY    _IOW(CWSID_IOCTL_TYPE, 0x22,int)

/* a magic number used by the CWSID_IOCTL_SIDTYPE and
   CWSID_IOCTL_CARDTYPE ioctls to identify a CatWeasel SID */
#define CWSID_MAGIC 0x100

/* maximum number of CatWeasel cards supported by this driver */
#define CWSID_MAX_NUM 4

#endif
