/*
  sid (c) 1999-2003 by Dirk Jagdmann <doj@cubic.org>

  This file is part of sid.

  sid is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or (at your
  option) any later version.

  sid is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
  License for more details.

  You should have received a copy of the GNU General Public License
  along with sid; if not, write to the Free Software Foundation, Inc.,
  59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
  
  $Header: /home/cvs/sidblaster/sid/load.cc,v 1.3 2003/05/17 19:37:10 doj Exp $
*/

#include "load.hh"
#include "mus.hh"
#include "raw.hh"
#include "stilinfo.hpp"

extern char musinfostring[10][33];

psid* load(const std::string& filename, C64 *c64)
{
  if(c64==0)
    return 0;

  FILE *f=fopen(filename.c_str(), "rb");
  if(f==0)
    return 0;

  c64->reset();

  // clear musinfostrings
  for(int i=0; i<10; i++)
    musinfostring[i][0]=0;

  psid *p=0;
  if(isPSID(f))
    {
      p=loadPSID(f, c64->memory());
    }
  else if(isMUS(f))
    {
      FILE *f2=0;
      std::string fn=filename;
      size_t len=fn.size();
      if(len>4)
	{
	  // we have a .mus and try to load correspondug .str
	  if(fn[len-4]=='.'
	     && fn[len-3]=='m'
	     && fn[len-2]=='u'
	     && fn[len-1]=='s')
	    {
	      fn[len-3]='s';
	      fn[len-2]='t';
	      fn[len-1]='r';
	      f2=fopen(fn.c_str(), "rb");
	    }
	  // we have a .str and have to load corresponding .mus
	  else if(fn[len-4]=='.'
		  && fn[len-3]=='s'
		  && fn[len-2]=='t'
		  && fn[len-1]=='r')
	    {
	      fn[len-3]='m';
	      fn[len-2]='u';
	      fn[len-1]='s';
	      FILE *t=fopen(fn.c_str(), "rb");
	      // .mus could not be loaded, abort
	      if(t==0)
		goto raus;
	      // make f a .mus and f2 a .str
	      f2=f;
	      f=t;
	    }
	}
      p=loadMUS(f, c64->memory(), f2);
      if(f2)
	{
	  c64->setBase(1, 0xD500);
	  fclose(f2);
	}
    }
  else
    {
      p=loadRAW(f, c64->memory());
    }

 raus:
  fclose(f);
  return p;
}
