/*
  sid (c) 1999-2003 by Dirk Jagdmann <doj@cubic.org>

  This file is part of sid.

  sid is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or (at your
  option) any later version.

  sid is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
  License for more details.

  You should have received a copy of the GNU General Public License
  along with sid; if not, write to the Free Software Foundation, Inc.,
  59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
  
  $Header: /home/cvs/sidblaster/sid/sidinfo.h,v 1.4 2003/05/22 01:20:56 doj Exp $
*/

#ifndef SIDINFO__H
#define SIDINFO__H

#include "sid.h"

class C64;

/**
   convert frequency f to a note string.

   @param f frequeny in Hz

   @return a string containing the corresponding note to f. This
   pointer is static, thus is's value does not change. Thus another
   call to freq2note() will overwrite the result of the prior
   call. You therefore may have to copy the returned string.
*/
char* freq2note(const double f);

/**
   initialize sid information window. curses must be initialized prior
   to calling this function. xoffset and yoffset contain the lower
   right corner upon return.

   @param xoffset top left corner of window.
   @param yoffset top left corner of window. yoffset is incremented by the height of the sid window.
   @param c64 C64 object which must be initialized with the correct number of SIDs.
*/
void sidinfo_init(int& xoffset, int& yoffset, C64 *c64);

/**
   print values into sid information window. sidinfo_init() must be called before using this function.
*/
void sidinfo_print(C64 *c64);

#endif
