/*
  sid (c) 1999-2003 by Dirk Jagdmann <doj@cubic.org>

  This file is part of sid.

  sid is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or (at your
  option) any later version.

  sid is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
  License for more details.

  You should have received a copy of the GNU General Public License
  along with sid; if not, write to the Free Software Foundation, Inc.,
  59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
  
  $Header: /home/cvs/sidblaster/sid/stilinfo.hpp,v 1.4 2003/05/22 01:20:56 doj Exp $
*/

#ifndef STILINFO__HPP
#define STILINFO__HPP

#include "stil.h"
#include <set>
#include <string>

/// @return an absolute filename of fn
std::string absFilename(std::string fn);

/**
   initializes STIL information window. curses must be initialized
   before calling this function. xoffset and yoffset are the top left
   corner of the window. The window fill fill the entire screen to the
   lower right corner of the screen. xoffset and yoffset contain the
   lower right cornet upon return.
*/
void stilinfo_init(int& xoffset, int& yoffset);

/**
   print STIL information for fn and subtune tuneno. stilinfo_init()
   must be called prior to this function.

   @param stil initialized STIL object
   @param fn filename of sid
   @param tuneno subtune number
*/
void stilinfo_print(STIL *stil, const std::string& fn, int tuneno);

/// type for information string container
typedef std::set<char*> infostr_t;
/// information string container
extern infostr_t infostr;

/**
   print all strings in infostr in the STIL window. stilinfo_init()
   must be called prior to this function.
*/
void stilinfo_printinfostr();

#endif
